SystemOrganization addCategory: #Geolocation!

Object subclass: #GLLocation
	instanceVariableNames: 'isoCountryCode longitude latitude zipPostalCode city countryName regionCode regionName timeZone gmtOffset dstOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geolocation'!

!GLLocation commentStamp: 'PaulDeBruicker 5/17/2010 13:01' prior: 0!
A GLLocation is a basic object to store the results from the GLLookup class.

Instance Variables
The only one of note:
	gmtOffset:		offset from GMT in seconds
!

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 12:50'!
city
	^ city! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 12:50'!
city: anObject
	city := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
countryName
	^ countryName! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
countryName: anObject
	countryName := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
dstOffset
	^ dstOffset! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
dstOffset: anObject
	dstOffset := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
gmtOffset
	^ gmtOffset! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
gmtOffset: anObject
	gmtOffset := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
isoCountryCode
	^ isoCountryCode! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
isoCountryCode: anObject
	isoCountryCode := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
latitude
	^ latitude! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
latitude: anObject
	latitude := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
longitude
	^ longitude! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
longitude: anObject
	longitude := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
regionCode
	^ regionCode! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
regionCode: anObject
	regionCode := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
regionName
	^ regionName! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
regionName: anObject
	regionName := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
timeZone
	^ timeZone! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
timeZone: anObject
	timeZone := anObject! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
zipPostalCode
	^ zipPostalCode! !

!GLLocation methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
zipPostalCode: anObject
	zipPostalCode := anObject! !

Object subclass: #GLLookup
	instanceVariableNames: 'ip location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geolocation'!

!GLLookup commentStamp: 'PaulDeBruicker 5/17/2010 13:03' prior: 0!
The class methods in this class provides basic access to the free geo-ip lookup service provided by:


 http://ipinfodb.com/ip_location_api.php

See their site for more info.  

It does not implement their services that allow you to look up more than one location at a time or look up a location using a domain name. !

!GLLookup classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/17/2010 12:05'!
findCity: anIPAddress
"Just does a country only lookup using the service at: http://ipinfodb.com/ip_location_api.php"
	^self new getCity: anIPAddress timeZone: false.! !

!GLLookup classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/17/2010 12:04'!
findCityAndTimeZone: anIPAddress
"Just does a country only lookup using the service at: http://ipinfodb.com/ip_location_api.php"
	^self new getCity: anIPAddress timeZone: true.! !

!GLLookup classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/17/2010 12:43'!
findCountry: anIPAddress
	^self new getCountry: anIPAddress.! !

!GLLookup classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/17/2010 12:05'!
findLongitudeAndLatitude: anIPAddress
"Just does a country only lookup using the service at: http://ipinfodb.com/ip_location_api.php"
	^self new getCity: anIPAddress timeZone: false.! !

!GLLookup methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/17/2010 12:49'!
getCity: anIPAddress timeZone: aBoolean
	|url httpResponse xml xmlResponse|
	ip:=anIPAddress.
	location:=GLLocation new.
	url:='http://ipinfodb.com/ip_query.php'.
	httpResponse:=self search: url timeZone: aBoolean.
	xml:=XMLDOMParser parseDocumentFrom: (ReadStream on: httpResponse contents).
	xmlResponse :=xml elementAt:#Response.
	((xmlResponse contentStringAt:'Status')='OK') ifTrue:[
	location countryName: (xmlResponse contentStringAt:'CountryName');
			 isoCountryCode: (xmlResponse contentStringAt:'CountryCode');
 			regionCode: (xmlResponse contentStringAt:'RegionCode');
		regionName: (xmlResponse contentStringAt:'RegionName');
		city: (xmlResponse contentStringAt:'City');
		zipPostalCode: (xmlResponse contentStringAt:'ZipPostalCode');
		latitude:(xmlResponse contentStringAt:'Latitude');
		longitude:(xmlResponse contentStringAt:'Longitude').
		aBoolean ifTrue:[location timeZone:(xmlResponse contentStringAt:'Timezone');
										gmtOffset: (xmlResponse contentStringAt:'Gmtoffset');
										dstOffset: (xmlResponse contentStringAt:'Dstoffset').
			
			].
	
	
	
	].
^location.! !

!GLLookup methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/17/2010 12:42'!
getCountry: anIPAddress
	|url httpResponse xml xmlResponse|
	ip:=anIPAddress.
	location:=GLLocation new.
	url:='http://ipinfodb.com/ip_query_country.php'.
	httpResponse:=self search: url timeZone: false.
	xml:=XMLDOMParser parseDocumentFrom: (ReadStream on: httpResponse contents).
	xmlResponse :=xml elementAt:#Response.
	((xmlResponse contentStringAt:'Status')='OK') ifTrue:[
	location countryName: (xmlResponse contentStringAt:'CountryName').
	location isoCountryCode: (xmlResponse contentStringAt:'CountryCode').].
^location.! !

!GLLookup methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
ip
	^ ip! !

!GLLookup methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
ip: anObject
	ip := anObject! !

!GLLookup methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
location
	^ location! !

!GLLookup methodsFor: 'accessing' stamp: 'PaulDeBruicker 5/17/2010 11:57'!
location: anObject
	location := anObject! !

!GLLookup methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 5/17/2010 12:45'!
search: aUrl timeZone: aBoolean
	|args|
	aBoolean ifTrue: [args:='ip=', ip , '&timezone=true' ]ifFalse:[args:='ip=' , ip ] .

	^HTTPSocket httpGetDocument: aUrl 
					args: args
					accept: 'text/xml'.! !

Object subclass: #GLLookupMySQL
	instanceVariableNames: 'ip location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geolocation'!

!GLLookupMySQL classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
findCity: anIPAddress
"Just does a country only lookup using the service at: http://ipinfodb.com/ip_location_api.php"
	^self new getCity: anIPAddress timeZone: false.! !

!GLLookupMySQL classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
findCityAndTimeZone: anIPAddress
"Just does a country only lookup using the service at: http://ipinfodb.com/ip_location_api.php"
	^self new getCity: anIPAddress timeZone: true.! !

!GLLookupMySQL classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
findCountry: anIPAddress
	^self new getCountry: anIPAddress.! !

!GLLookupMySQL classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
findLongitudeAndLatitude: anIPAddress
"Just does a country only lookup using the service at: http://ipinfodb.com/ip_location_api.php"
	^self new getCity: anIPAddress timeZone: false.! !

!GLLookupMySQL methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/24/2010 09:12'!
getCity: anIPAddress timeZone: aBoolean
	| spec connection statement resultSet  |
	ip:=anIPAddress.
	location:=GLLocation new.
Socket initializeNetwork.
spec :=    (JdmConnectionSpec new initialize
        user: 'ip'; password: 'geolocation1';
        host: (NetNameResolver addressForName: 'localhost');
        database: 'ipinfodb_one_table_full_country';
        port: 3306).


connection := JdmConnection on: spec.
statement := connection createStatement.
resultSet := statement executeQuery: 'select * from ip_group_country where ip_start <= inet_aton("', anIPAddress , '") order by ip_start desc limit 1'.
[resultSet next]
whileTrue: [
	location  isoCountryCode: (resultSet valueNamed: 'country_code').
].			

connection close.	
	
	

^location.! !

!GLLookupMySQL methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 10/15/2010 09:45'!
getCountry: anIPAddress 
	| spec connection statement resultSet  |
	ip:=anIPAddress.
	location:=GLLocation new.
Socket initializeNetwork.
spec :=    (JdmConnectionSpec new initialize
        user: 'ip'; password: 'geolocation1';
        host: (NetNameResolver addressForName: 'localhost');
        database: 'ipinfodb_one_table_full_country';
        port: 3306).


connection := JdmConnection on: spec.
statement := connection createStatement.
resultSet := statement executeQuery: 'select * from ip_group_country where ip_start <= inet_aton("', anIPAddress , '") order by ip_start desc limit 1'.
[resultSet next]
whileTrue: [
	location  isoCountryCode: (resultSet valueNamed: 'country_code').
	location  countryName: (resultSet valueNamed: 'country_name').
].			

connection close.	
	
	

^location.! !

!GLLookupMySQL methodsFor: 'accessing' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
ip
	^ ip! !

!GLLookupMySQL methodsFor: 'accessing' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
ip: anObject
	ip := anObject! !

!GLLookupMySQL methodsFor: 'accessing' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
location
	^ location! !

!GLLookupMySQL methodsFor: 'accessing' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
location: anObject
	location := anObject! !

!GLLookupMySQL methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 9/22/2010 14:17'!
search: aUrl timeZone: aBoolean
	|args|
	aBoolean ifTrue: [args:='ip=', ip , '&timezone=true' ]ifFalse:[args:='ip=' , ip ] .

	^HTTPSocket httpGetDocument: aUrl 
					args: args
					accept: 'text/xml'.! !
